unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button1: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Var
  BmpFond   : Tbitmap; //BitMap qui servira  stocker l'image original du fond
  BmpManoeuvre: TBitmap; //BitMap qui servira comme zone de travail non vue
  BmpImage  : TBitmap; // BitMap qui contiendra l'image que l'on veut faire dplacer
  RNew      : TRect; // Rectangle nouvelle position de l'image anime.
  ROld      : TRect; //Rectangle ancienne position de l'image annime
  RImage    : TRect; // Rectangle de la taille de BmpImage;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BmpFond:=TBitmap.Create;  // Cration du BitMap qui servira  stocker l'image original du fond
  BmpManoeuvre   :=TBitmap.Create;  // Cration du BitMap qui servira comme zone de travail non vue
  BmpImage:=TBitmap.Create; // Cration du BitMap qui contiendra l'image que l'on veut faire dplacer.
  BmpFond.LoadFromFile('quadrill.bmp'); // Chargement du fichier .bmp dans BmpFond
  BmpFond.Width:=PaintBox1.Width; // Dimensionnement de BmpFond
  BmpFond.Height:=PaintBox1.Height;
  BmpManoeuvre.Assign(BmpFond);
  BmpImage.LoadFromFile('Athena.bmp');
  RImage:=Rect(0,0,BmpImage.Width,BmpImage.Height);
        // Un vnement OnPaint (procedure TForm1.FormPaint) est appel  la fin du Create
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  BmpFond.free;
  BmpManoeuvre.free;
  BmpImage.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  PaintBox1.Canvas.Draw(0,0,BmpManoeuvre);
end;


procedure TForm1.Button1Click(Sender: TObject);
Var
  i,j:Integer;
  RUnion:TRect;
begin
  BmpImage.Transparent := True;                             // activation du mode transparent
  BmpImage.TransParentColor := BmpImage.canvas.pixels[1,1];// tous les pixels qui ont la mme couleur que le pixel n1 seront considrs par la mthode Draw comme transparents
  RNew:=rect(0,0,RImage.Right,RImage.Bottom);             // la premire image se placera en haut  gauche
  ROld:=RNew;
  For i:=1 to 200 do
  begin
    ROld:=RNew; // on mmorise le rectangle qui corespond  la zone  effacer = l'ancienne zone dessine
    RNew:=rect(RNew.Left+1,RNew.Top+1 ,RNew.Right+1 ,RNew.Bottom+1 );// dplacement du rectangle d'un pixel vers la droite et d'un pixel vers le bas
    BmpManoeuvre.Canvas.CopyRect(ROld,bmpFond.canvas,ROld);         //effacement
    //BmpManoeuvre.Canvas.CopyRect(RNew ,BmpImage.Canvas, RImage); // solution plus rapide mais gre moins facilement les transparents
    BmpManoeuvre.Canvas.Draw(RNew.left,RNew.top,BmpImage);        // dessin
    UnionRect(RUnion,ROld,RNew); // rectangle incluant les 2 rectangles modifis
    PaintBox1.Canvas.CopyRect(RUnion,BmpManoeuvre.Canvas,RUnion);//on ne recopie ainsi que ce qui est ncssaire
    for j:=1 to 100 do application.ProcessMessages;  // boucle inutile. Uniquement pour ralentir le dplacement de l'image
  end;
  BmpImage.TransparentMode := tmAuto; // remise aux valeurs de transparence par dfaut
end;


end.


